"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

require("./select.style.scss");

var _classnames = _interopRequireDefault(require("classnames"));

var _SelectError = _interopRequireDefault(require("./SelectError"));

var _shortid = _interopRequireDefault(require("shortid"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Select =
/*#__PURE__*/
function (_Component) {
  _inherits(Select, _Component);

  function Select(props) {
    var _this;

    _classCallCheck(this, Select);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Select).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "isMounted", false);

    _defineProperty(_assertThisInitialized(_this), "isBlur", false);

    _defineProperty(_assertThisInitialized(_this), "timeouts", []);

    _defineProperty(_assertThisInitialized(_this), "searchInput", _react["default"].createRef());

    _defineProperty(_assertThisInitialized(_this), "hiddenInput", _react["default"].createRef());

    _defineProperty(_assertThisInitialized(_this), "state", {
      isUp: false,
      isDown: true,
      isOpen: false,
      focus: '',
      value: '',
      visibleOptions: [],
      prevValue: '',
      //  used to update state based on props
      prevOptions: [],
      //  used to update state based on props
      prevFocus: null,
      //  used to update state based on props
      userSearches: '',
      isClick: false,
      hasOptions: false
    });

    _defineProperty(_assertThisInitialized(_this), "resolveOptionNameBy", function (value) {
      if (_this.props.options.length) {
        var opt = _this.props.options.find(function (opt) {
          return opt.value === value;
        });

        return opt && opt.label;
      }

      return '';
    });

    _defineProperty(_assertThisInitialized(_this), "handleSearchInput", function (evt) {
      var searches = evt.target.value.toLowerCase();

      _this.setState({
        visibleOptions: _this.props.options,
        userSearches: searches,
        hasOptions: false
      }, function () {
        var filtered = _this.props.options.filter(function (opt) {
          return opt.label.toLowerCase().includes(searches);
        }); // console.clear()


        if (searches.length && !filtered.length) {
          _this.setState({
            hasOptions: true,
            visibleOptions: filtered
          });

          return;
        }

        _this.setState({
          visibleOptions: filtered
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleBlurControl", function () {
      if (!_this.isBlur) return;
      var delayAfterStateWasSet = 200;
      var timeout = setTimeout(function () {
        _this.timeouts.push(timeout);

        _this.setState({
          isOpen: false
        });

        _this.isBlur = false;
        clearTimeout(timeout);
      }, delayAfterStateWasSet);
    });

    _defineProperty(_assertThisInitialized(_this), "handleOpen", function (evt) {
      var _this$props = _this.props,
          disabled = _this$props.disabled,
          options = _this$props.options;
      if (disabled) return;
      if (!_this.isMounted) return;

      _this.applyBlur(evt);

      _this.setState({
        isOpen: !_this.state.isOpen
      }, function () {
        _this.manageFocus();

        if (_this.state.isOpen) return;

        _this.setState({
          userSearches: '',
          visibleOptions: options,
          hasOptions: false
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "applyBlur", function (evt) {
      if (evt.currentTarget.id.includes('select-control')) {
        _this.isBlur = true;
        evt.stopPropagation();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "manageFocus", function () {
      var timeout = 0;
      var searchable = _this.props.searchable;

      var tap = function tap(target) {
        timeout = setTimeout(function () {
          _this.timeouts.push(timeout);

          if (target && target.current) target.current.focus();
          clearTimeout(timeout);
        }, 14);
      };

      if (searchable) tap(_this.searchInput);
      tap(_this.hiddenInput);
    });

    _defineProperty(_assertThisInitialized(_this), "triggerOnSelectChanged", function (_ref) {
      var label = _ref.label,
          value = _ref.value;
      var onChange = _this.props.onChange;

      _this.setState({
        isOpen: !_this.state.isOpen,
        value: value
      }, function () {
        var option = {
          label: label,
          value: value // console.log('passed outside', option)

        };
        onChange && onChange({
          option: option
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "getStyleAndCss", function () {
      var styles = {};
      var _this$props2 = _this.props,
          block = _this$props2.block,
          type = _this$props2.type,
          disabled = _this$props2.disabled;
      var isOpen = _this.state.isOpen;
      var classes = (0, _classnames["default"])("select-wrap -".concat(type), block && '-block', isOpen && '-border', disabled && '-disabled');
      var attr = {
        className: classes,
        style: styles
      };
      return attr;
    });

    return _this;
  }

  _createClass(Select, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.isMounted = true;
      this.validateProps();
      this.manageNullable();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.isMounted = false;

      for (var i = 0; i < this.timeouts.length; i++) {
        clearTimeout(this.timeouts[i]);
        this.timeouts[i] = null;
        if (i === this.timeouts.length - 1) this.timeouts.length = 0;
      }
    }
  }, {
    key: "render",
    value: function render() {
      var searchable = this.props.searchable;
      if (searchable) return this.renderSelectSearchable();
      return this.renderSelect();
    }
  }, {
    key: "renderSelectSearchable",
    value: function renderSelectSearchable() {
      var _this$state = this.state,
          value = _this$state.value,
          isOpen = _this$state.isOpen,
          userSearches = _this$state.userSearches,
          hasOptions = _this$state.hasOptions;
      var searchInputClasses = (0, _classnames["default"])('searchbar', isOpen && '-show');
      var name = this.resolveOptionNameBy(value);
      var classes = isOpen && '-focus' || '';

      var unique = _shortid["default"].generate();

      var optionWarn = hasOptions && isOpen && '-show' || '';
      return _react["default"].createElement(Wrapper, _extends({
        id: "select-control-".concat(unique)
      }, this.mixedProps(), {
        onClick: this.handleOpen
      }), _react["default"].createElement("span", {
        className: classes
      }, isOpen ? _react["default"].createElement("input", {
        ref: this.searchInput,
        className: searchInputClasses,
        type: "text",
        value: userSearches,
        onBlur: this.handleBlurControl,
        onChange: this.handleSearchInput
      }) : _react["default"].createElement("div", {
        className: "selected-value",
        title: name
      }, _react["default"].createElement("p", null, name)), this.lists(), _react["default"].createElement("div", {
        className: "svg-wrap"
      }, this.renderSVGArrow())), _react["default"].createElement("div", {
        className: "no-options ".concat(optionWarn)
      }, "No options"));
    }
  }, {
    key: "renderSelect",
    value: function renderSelect() {
      var _this$state2 = this.state,
          value = _this$state2.value,
          isOpen = _this$state2.isOpen;
      var name = this.resolveOptionNameBy(value);
      var classes = isOpen && '-focus' || '';

      var unique = _shortid["default"].generate();

      return _react["default"].createElement(Wrapper, _extends({
        id: "select-control-".concat(unique)
      }, this.mixedProps(), {
        onClick: this.handleOpen
      }), _react["default"].createElement("span", {
        className: classes
      }, _react["default"].createElement("input", {
        className: "as-hidden-input",
        type: "text",
        ref: this.hiddenInput,
        onBlur: this.handleBlurControl
      }), _react["default"].createElement("div", {
        className: "selected-value",
        title: name
      }, _react["default"].createElement("p", null, name)), this.lists(), _react["default"].createElement("div", {
        className: "svg-wrap"
      }, this.renderSVGArrow())));
    }
  }, {
    key: "manageNullable",
    value: function manageNullable() {
      var _this2 = this;

      // TODO: Increasing when props are coming from the dataProvider.
      var _this$props3 = this.props,
          nullable = _this$props3.nullable,
          value = _this$props3.value;

      if (nullable) {
        var found = this.state.visibleOptions.filter(function (opt) {
          return opt.value === null;
        });
        !found.length && this.state.visibleOptions.unshift({
          label: this.props.placeholder,
          value: null
        });
      } else {
        var _found = this.state.visibleOptions.filter(function (opt) {
          return opt.value === null;
        });

        _found.length && this.state.visibleOptions.forEach(function (opt, idx) {
          if (opt.value === null) _this2.state.visibleOptions.splice(idx, 1);
        });
      } // nullable no value set


      if (nullable && !value) {
        this.setState({
          value: null
        });
      }
    }
  }, {
    key: "validateProps",
    value: function validateProps() {
      var _this$props4 = this.props,
          nullable = _this$props4.nullable,
          value = _this$props4.value,
          options = _this$props4.options,
          type = _this$props4.type;

      if (!nullable && !value) {
        throw _SelectError["default"].fromMissingValueOnNonNullable();
      }

      if (nullable && !options) {
        throw _SelectError["default"].fromAddingNullableWithoutOptions();
      }

      var values = options && options.map(function (o) {
        return o.value;
      }) || [];

      if (value && !values.includes(value)) {
        throw _SelectError["default"].fromNonExistentValueOnOptions(value);
      }

      if (type && ['danger', 'primary', 'success', 'warning'].indexOf(type) === -1) {
        throw _SelectError["default"].fromNonExistentValueOnPrimitives(type);
      }
    } // # Borrowed an `arrow` from ant-design

  }, {
    key: "renderSVGArrow",
    value: function renderSVGArrow() {
      var isOpen = this.state.isOpen;
      return _react["default"].createElement("svg", {
        viewBox: "64 64 896 896",
        focusable: "false",
        className: "ant-arrow ".concat(isOpen ? '-rotate' : ''),
        "data-icon": "down",
        width: "1em",
        height: "1em",
        "aria-hidden": "true"
      }, _react["default"].createElement("path", {
        d: "M884 256h-75c-5.1 0-9.9 2.5-12.9 6.6L512 654.2 227.9 262.6c-3-4.1-7.8-6.6-12.9-6.6h-75c-6.5 0-10.3 7.4-6.5 12.7l352.6 486.1c12.8 17.6 39 17.6 51.7 0l352.6-486.1c3.9-5.3.1-12.7-6.4-12.7z"
      }));
    }
  }, {
    key: "lists",
    value: function lists() {
      var _this3 = this;

      var _this$state3 = this.state,
          isDown = _this$state3.isDown,
          isUp = _this$state3.isUp,
          isOpen = _this$state3.isOpen,
          value = _this$state3.value;
      var classes = (0, _classnames["default"])('select-options', isDown && '-down', // > direction
      isUp && '-up', // not application on this version
      isOpen && '-open');

      var setActiveBy = function setActiveBy(opt, value) {
        var isEqual = opt.value === value;
        return isEqual && '-active' || '';
      };

      return this.state.visibleOptions.length ? _react["default"].createElement("ul", {
        className: classes
      }, this.state.visibleOptions && this.state.visibleOptions.map(function (opt, optIdx) {
        return _react["default"].createElement("li", {
          key: optIdx,
          className: setActiveBy(opt, value),
          onClick: function onClick(evt) {
            evt.stopPropagation();

            _this3.triggerOnSelectChanged(opt);
          }
        }, opt && opt.label);
      })) : _react["default"].createElement("span", null);
    }
  }, {
    key: "getNativeAttr",
    value: function getNativeAttr() {
      return this.props;
    }
  }, {
    key: "getExtraAttr",
    value: function getExtraAttr() {
      return {};
    }
  }, {
    key: "mixedProps",
    value: function mixedProps() {
      return _objectSpread({}, this.getStyleAndCss(), {}, this.getNativeAttr(), {}, this.getExtraAttr());
    }
  }, {
    key: "selectedOption",
    get: function get() {
      var options = this.props.options;
      var value = this.state.value;
      return options.find(function (d) {
        return d.value === value;
      });
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (props.value !== state.prevValue || props.options !== state.prevOptions || props.focus !== state.prevFocus) {
        return {
          prevValue: props.value,
          value: props.value,
          visibleOptions: props.options,
          prevOptions: props.options,
          focus: props.focus,
          prevFocus: props.focus
        };
      }

      return null;
    }
  }]);

  return Select;
}(_react.Component);

var Wrapper = _react["default"].forwardRef(function (props, ref) {
  var sanitizer = function sanitizer(obj, blacklist) {
    var sanitized = Object.assign({}, obj); //console.log(props.id)

    Object.keys(sanitized).forEach(function (key) {
      if (blacklist.includes(key)) delete sanitized[key];
    });
    return sanitized;
  };

  var newProps = sanitizer(props, ['searchable', 'options', 'nullable', 'block', 'type', 'placeholder', 'focus', 'disabled', 'value']);
  return _react["default"].createElement("div", _extends({}, newProps, {
    ref: ref
  }), props.children);
});

Select.defaultProps = {
  searchable: false,
  nullable: false,
  block: false,
  type: 'primary',
  placeholder: 'Select an option',
  focus: false,
  disabled: false
};
Select.propTypes = {
  searchable: _propTypes["default"].bool,
  options: _propTypes["default"].array,
  nullable: _propTypes["default"].bool,
  block: _propTypes["default"].bool,
  type: _propTypes["default"].oneOf(['primary', 'warning', 'success', 'danger']),
  placeholder: _propTypes["default"].string,
  focus: _propTypes["default"].bool,
  disabled: _propTypes["default"].bool
};
var _default = Select;
exports["default"] = _default;